﻿Shader "Simple/SimpleAlphaShader" {
	Properties {
		_Color ("Color", Color) = (1,1,1,1)        // Unity側で色をセット
	}
	SubShader {
		// 描画タイプ。 Opaque=不透明　Transparent=半透明　TransparentCutout=抜き
		Tags { "RenderType"="Transparent" "Queue" = "Transparent" }    

		// CGPROGRAM　〜　ENDCG  この中にシェーダーを書く
		CGPROGRAM    

		// Surfaceと書くことででサーフェスシェーダーであることを宣言する。
		// surfの部分は関数名、Lambertの部分はライティングモードを指定。
		// ライトモードは、Lambert=拡散反射光　BlinnPhongは鏡面反射光
		#pragma surface surf Lambert alpha

		// Unityからシェーダーに渡される構造体
		struct Input {
			float4 color : COLOR;    // 色
		};

		// Propertiesで宣言した変数を同名で宣言。UnityEditorから渡された値を扱えるようになる
		fixed4 _Color;


		// #pragmaで宣言したsurface関数
		// この関数の中を書き換えて質感を制御する
		void surf (Input IN, inout SurfaceOutput o) {
			o.Albedo = _Color.rgb;
			o.Alpha = _Color.a;
		}
		ENDCG
	}
	FallBack "Diffuse"
}